package org.phosphoresce.webcore.ext.hibernate4.annotation;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import org.phosphoresce.webcore.ext.hibernate4.transaction.AbstractGenericHibernateDAO;
import org.phosphoresce.webcore.ext.hibernate4.transaction.AbstractHibernateEntity;

/**
 * Hibernateを利用するデータベースアクセスオブジェクトクラスの注釈インタフェースを提供します。<br>
 * <br>
 * {@link AbstractGenericHibernateDAO}を継承したデータベースアクセスオブジェクトクラスを実装する場合、必ずこのアノテーションを付与する必要があります。<br>
 * 
 * @author Kitagawa<br>
 * 
 *<!--
 * 更新日		更新者			更新内容
 * 2013/02/01	Kitagawa		新規作成
 *-->
 */
@Inherited
@Retention(RetentionPolicy.RUNTIME)
@Target({ ElementType.TYPE })
@Documented
public @interface HibernateDAO {

	/**
	 * データベースアクセスオブジェクトに対応するエンティティクラスを指定します。<br>
	 */
	public abstract Class<? extends AbstractHibernateEntity> entity();
}
